scriptName DSerEnchantArrowFX extends activemagiceffect
;Adds the FX to the Arrow

;-- Properties --------------------------------------
spell property EnchantedArrowFX_Fire auto
spell property EnchantedArrowFX_Ice auto
spell property EnchantedArrowFX_Magic auto
spell property EnchantedArrowFX_Shock auto


function OnEffectStart(Actor akTarget, Actor akCaster)
	akCaster.AddSpell(EnchantedArrowFX_Fire, false)
	akCaster.AddSpell(EnchantedArrowFX_Ice, false)
	akCaster.AddSpell(EnchantedArrowFX_Magic, false)
	akCaster.AddSpell(EnchantedArrowFX_Shock, false)
endFunction

function OnEffectFinish(Actor akTarget, Actor akCaster)
	akCaster.RemoveSpell(EnchantedArrowFX_Fire)
	akCaster.RemoveSpell(EnchantedArrowFX_Ice)
	akCaster.RemoveSpell(EnchantedArrowFX_Magic)
	akCaster.RemoveSpell(EnchantedArrowFX_Shock)
endFunction
